SystemOrganization addCategory: #'Pier-EmailSender'!

SMTPClient subclass: #WAMailSenderSmtp
	instanceVariableNames: 'emailTo subject message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-EmailSender'!

!WAMailSenderSmtp class methodsFor: 'as yet unclassified' stamp: 'kph 9/23/2008 00:13'!
application

	^ WACurrentSession value application! !

!WAMailSenderSmtp class methodsFor: 'as yet unclassified' stamp: 'kph 9/22/2008 23:48'!
smtpHostIp

	^ NetNameResolver addressForName: ((self application preferenceAt: #smtpHost) ifNil: [ 'localhost' ])! !

!WAMailSenderSmtp class methodsFor: 'as yet unclassified' stamp: 'kph 9/22/2008 23:48'!
smtpPort

	^ (self application preferenceAt: #smtpPort) ifNil: [ 25 ]! !

!WAMailSenderSmtp class methodsFor: 'as yet unclassified' stamp: 'kph 9/22/2008 23:50'!
smtpRecipient

	^ (self application preferenceAt: #smtpRecipient) ifNil: [ '' ]  ! !

!WAMailSenderSmtp class methodsFor: 'as yet unclassified' stamp: 'kph 1/14/2009 22:14'!
smtpSender

	^ self client smtpSender! !

!WAMailSenderSmtp methodsFor: 'accessing' stamp: 'kph 9/22/2008 23:56'!
emailTo
	"Answer the value of emailTo"

	^ emailTo ifNil: [ self class smtpRecipient ]! !

!WAMailSenderSmtp methodsFor: 'accessing' stamp: 'kph 9/22/2008 23:55'!
emailTo: anObject
	"Set the value of emailTo"

	emailTo := anObject! !

!WAMailSenderSmtp methodsFor: 'accessing' stamp: 'kph 9/22/2008 23:58'!
message
	"Answer the value of message"

	^ message! !

!WAMailSenderSmtp methodsFor: 'accessing' stamp: 'kph 9/22/2008 23:58'!
message: anObject
	"Set the value of message"

	message := anObject! !

!WAMailSenderSmtp methodsFor: 'action' stamp: 'kph 9/23/2008 00:50'!
send
 
	[ self sendBasic ] on: ConnectionTimedOut do: [ :ex | self log smtp error: ex messageText. ^ false ].

	^ true! !

!WAMailSenderSmtp methodsFor: 'action' stamp: 'kph 1/14/2009 23:10'!
sendBasic
 
	| text |
	
	self openOnHost: self class smtpHostIp port: self class smtpPort.
	
	(self emailTo splitOn: ',') in: [ :to |
		
		to isEmpty ifTrue: [ ^ false ].
		
		text := 'Subject: ', self subject , String cr, String cr, self message.
		
		self mailFrom: self class smtpSender to: to text: text; quit.
		
	].

	 ! !

!WAMailSenderSmtp methodsFor: 'accessing' stamp: 'kph 9/23/2008 01:39'!
standardTimeout

	^ 5! !

!WAMailSenderSmtp methodsFor: 'accessing' stamp: 'kph 9/23/2008 00:03'!
subject
	"Answer the value of subject"

	^ subject! !

!WAMailSenderSmtp methodsFor: 'accessing' stamp: 'kph 9/23/2008 00:03'!
subject: anObject
	"Set the value of subject"

	subject := anObject! !

!WACallbackStream methodsFor: '*pier-emailsender' stamp: 'kph 7/15/2008 20:10'!
request

	^ request! !

PRWidget subclass: #PREmailForm
	instanceVariableNames: 'emailTo formHtml'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-EmailSender'!

!PREmailForm commentStamp: 'kph 9/23/2008 00:06' prior: 0!
So this emails the fields of any form placed in a pier page. 

Useful for migrating forms in an existing website.

!

!PREmailForm class methodsFor: 'as yet unclassified' stamp: 'kph 7/8/2008 17:17'!
canBeRoot

^ true! !

!PREmailForm class methodsFor: 'as yet unclassified' stamp: 'kph 7/16/2008 15:37'!
descriptionAcknowledgementText
	^ MAStringDescription new
		accessor: #acknowledgementText;
		default: 'Request Submitted';
		label: 'Acknowledgement Text';
		beSetting;
		priority: 420;
		yourself
		
 ! !

!PREmailForm class methodsFor: 'as yet unclassified' stamp: 'kph 7/16/2008 15:38'!
descriptionButtonText
	^ MAStringDescription new
		accessor: #buttonText;
		default: 'Send Request';
		label: 'Submit Button Text';
		beSetting;
		priority: 420;
		yourself
		
 ! !

!PREmailForm class methodsFor: 'as yet unclassified' stamp: 'kph 7/15/2008 19:42'!
descriptionEmailTo
	^ MAStringDescription new
		accessor: #emailTo;
		label: 'Send Email To';
		beSetting;
		priority: 400;
		yourself
		
 ! !

!PREmailForm class methodsFor: 'as yet unclassified' stamp: 'kph 7/16/2008 15:38'!
descriptionFinalDestination
	^ PRStructureDescription new
		accessor: #finalDestination;
		label: 'After submit goto page';
		beSetting;
		priority: 430;
		yourself
		
 ! !

!PREmailForm class methodsFor: 'as yet unclassified' stamp: 'kph 7/15/2008 19:55'!
descriptionFormHtml
	^ MAMemoDescription new
		accessor: #formHtml;
		label: 'Form HTML';
		beSetting;
		priority: 410;
		yourself
		
 ! !

!PREmailForm class methodsFor: 'as yet unclassified' stamp: 'kph 7/8/2008 18:27'!
isAbstract

^ false! !

!PREmailForm class methodsFor: 'as yet unclassified' stamp: 'kph 7/15/2008 19:40'!
label

	^ 'email form'! !

!PREmailForm methodsFor: 'as yet unclassified' stamp: 'kph 7/16/2008 15:38'!
acknowledgementText

	^ self read: #descriptionAcknowledgementText! !

!PREmailForm methodsFor: 'as yet unclassified' stamp: 'kph 7/16/2008 15:32'!
buttonText

	^ self read: #descriptionButtonText! !

!PREmailForm methodsFor: 'accessing' stamp: 'kph 9/23/2008 00:02'!
emailTo
	 
	^ self read: #descriptionEmailTo! !

!PREmailForm methodsFor: 'as yet unclassified' stamp: 'kph 7/15/2008 20:15'!
fields

^ self session currentRequest fields	
 ! !

!PREmailForm methodsFor: 'as yet unclassified' stamp: 'kph 7/16/2008 15:39'!
finalDestination

	^ self read: #descriptionFinalDestination! !

!PREmailForm methodsFor: 'accessing' stamp: 'kph 7/15/2008 20:03'!
formHtml
	 
	^ (self read: #descriptionFormHtml) ifNil: [ 'no form defined ' ]! !

!PREmailForm methodsFor: 'as yet unclassified' stamp: 'kph 7/17/2008 05:46'!
isSubmission

	self fields at: 'submit' ifAbsent: [ ^ false ].
	
	^ true! !

!PREmailForm methodsFor: 'as yet unclassified' stamp: 'kph 7/16/2008 15:26'!
messageSubject

	^ self owner title! !

!PREmailForm methodsFor: 'as yet unclassified' stamp: 'kph 9/23/2008 00:05'!
messageText
	| s |
	
	
	s := String new writeStream. 

	self fields in: [ :f |
		
		(f keys remove: 'submit'; yourself) asSortedCollection do: [ :k |
		
			k first ~= $_ ifTrue: [ s << k << ' : ' << (f at: k) ; cr ]
		
	]].
	^ s contents.
	
  ! !

!PREmailForm methodsFor: 'as yet unclassified' stamp: 'kph 7/17/2008 05:47'!
processCallbackStream: a
	
  self isSubmission ifTrue: [ 
	[ self sendEmail ] on: TelnetProtocolError 
	do: [ :ex | self inform: 'smtp not configured correctly' ].
  ].
  super processCallbackStream: a! !

!PREmailForm methodsFor: 'as yet unclassified' stamp: 'kph 7/22/2008 09:03'!
renderContentOn: html

	html form
		name: 'theform';
		 with: [
		self renderWiki: self formHtml on: html.
		
		html submitButton
			
			callback: [  self shoreInform: self acknowledgementText.
						self gotoStructure: self finalDestination. ];
			name: 'submit';
			text: self buttonText.
	]! !

!PREmailForm methodsFor: 'as yet unclassified' stamp: 'kph 9/23/2008 00:13'!
sendEmail
 
	^ (WAMailSenderSmtp new
		emailTo: self emailTo;
		subject: self messageSubject;
		message: self messageText;
		send)! !

WASystemConfiguration subclass: #WASmtpConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-EmailSender'!

!WASmtpConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 9/23/2008 00:17'!
attributes
	^ Array
		with: (WAStringAttribute key: #smtpRecipient group: #smtp)
		with: (WAStringAttribute key: #smtpHost group: #smtp)
		with: (WANumberAttribute key: #smtpPort group: #smtp)
		
! !

!WASmtpConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 7/8/2008 18:00'!
smtpHost

	^ 'localhost'! !

!WASmtpConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 7/8/2008 17:59'!
smtpPort

	^ 25! !

!WASmtpConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 7/15/2008 19:57'!
smtpRecipient

	^ 'knowlefreecycler@yahoo.co.uk'! !
